/* Solutie cu programare dinamica la problema Numarati tipurile
 * concursul de programare Alexandru Rogojan 2010
 * Marius Minea, mai 2010
 */

#include <math.h>
#include <stdint.h>
#include <stdio.h>

#define NUM	64

uintmax_t val[NUM+1] = {0, 1, 2};

typedef struct { uintmax_t n1, n2; } pair_t;

uintmax_t min(uintmax_t a, uintmax_t b) { return a < b ? a : b; }

pair_t decomp(uintmax_t n)			// descompune n in n1 si n2
{
  pair_t r = (pair_t){ 0, 0 };
  while (n % 2 == 0) { n /= 2; ++r.n1; }
  r.n2 = n / 2;
  return r;
}

uintmax_t ordmin(unsigned n)
{
  for (unsigned k = 3; k <= n; ++k) {
    val[k] = min(2*val[k-1]+1, min(2*(2*val[k-2]+1), 4*(2*val[k-3]+1)));
    for (unsigned i = 3; i < k; ++i) {
      if (val[i] + log(2*val[k-1-i]+1) < log(val[k])) // de siguranta
	val[k] = (1 << val[i]) * (2*val[k-1-i]+1);
    }
  }
  return val[n];
}

void printtype_arr(uintmax_t n);

void printtype_par(uintmax_t n)	// scrie tip, in paranteze daca e cazul
{
  if (n > 0) {			// tip compus, trebuie paranteze
    putchar('(');
    printtype_arr(n);		// scrierea propriu-zisa
    putchar(')');
  } else putchar ('T');
}

void printtype_arr(uintmax_t n)	// scrie tip compus, n > 0
{
  pair_t d = decomp(n);		// descompune pe n
  printtype_par(d.n1);		// tipul din stanga sagetii
  printf("->");
  printtype_par(d.n2);		// tipul din dreapta sagetii
}

unsigned bits(uintmax_t n)	// pe cati biti se scrie n ?
{
  unsigned r = 1;
  while (n > 1) { n /= 2; ++r; }
  return r;
}

int main(void)			// citeste stdin, scrie stdout
{
  unsigned n;
  if (scanf("%u", &n) != 1) {
    fprintf(stderr, "numar incorect\n");
    return 1;
  }
  if (n > bits(UINTMAX_MAX)) {
    fprintf(stderr, "abandon: ar genera depasire\n");
    return 1;
  }
  if (n > 0) {
    uintmax_t r = ordmin(n);
    printtype_arr(r);
    printf("\n%ju\n", r);
  } else printf("T\n0\n");
  return 0;
}
