/* Solutie cu recurenta directa la problema Numarati tipurile
 * Concursul de programare Alexandru Rogojan 2010
 * Marius Minea, mai 2010
 */

#include <stdint.h>
#include <stdio.h>

uintmax_t print3(int n)		// scrie/calculeaza pt. multiplu de 3
{
  uintmax_t r = 0;		// rezultatul
  if (n > 0) {			// apare grupul (T->T)->T
    printf("((T->T)->T)->");
    if (n > 3) putchar('(');	// tip(n-3) e compus -> necesita paranteze
    r = 4 * (2*print3(n-3)+1);
    if (n > 3) putchar(')');
  } else putchar('T');		// n = 0
  return r;
}

uintmax_t printtype(int n)
{
  int r3 = n % 3;
  if (r3 == 2) printf("(T->T)->");
  else if (r3 == 1) printf("T->");
  if (r3 && n > 2) putchar('(');	// tip compus la dreapta lui ->
  uintmax_t r = print3(n-r3);
  if (r3) {
    r = (1 << (r3-1)) * (2*r+1);
    if (n > 2) putchar(')');
  }
  return r;
}

unsigned bits(uintmax_t n)		// pe cati biti se scrie n ?
{
  unsigned r = 1;
  while (n > 1) { n /= 2; ++r; }
  return r;
}

int main(void)				// citeste stdin, scrie stdout
{
  unsigned n;
  if (scanf("%u", &n) != 1) {
    fprintf(stderr, "numar incorect\n");
    return 1;
  }
  if (n > bits(UINTMAX_MAX)) {
    fprintf(stderr, "abandon: ar genera depasire\n");
    return 1;
  }
  printf("\n%ju\n", printtype(n));
  return 0;
}
